

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Blue



extern int       Periods=5;
//---- buffers


double U_ShadowBuffer[];
double L_ShadowBuffer[];
double BodyBuffer[];

double U_Shadow[];
double L_Shadow[];
double Body[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,U_ShadowBuffer);
   SetIndexLabel(0, "Upper Shadow");
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,L_ShadowBuffer);
   SetIndexLabel(1, "Lower Shadow");
  
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,BodyBuffer);
   SetIndexLabel(2, "Body");

   ArraySetAsSeries(U_Shadow, true);
   ArraySetAsSeries(L_Shadow, true);
   ArraySetAsSeries(Body, true);

 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  ArrayResize(U_Shadow, Bars);
   ArrayResize(L_Shadow, Bars);
    ArrayResize(Body, Bars);
  
   
   int    counted_bars=IndicatorCounted();
   int i,    limit=Bars-counted_bars;
   
   
  for( i=limit; i>=0; i--)
   {
   U_Shadow[i]=High[i]-MathMax(Close[i],Open[i]);            
   L_Shadow[i]=MathMin(Close[i],Open[i])-Low[i];
   Body[i]=MathMax(Close[i],Open[i])-MathMin(Close[i],Open[i]);
  }
  
 for(i=limit; i>=0; i--)
 {
 
 U_ShadowBuffer[i]=iMAOnArray(U_Shadow,0,Periods,0,MODE_SMA,i);
 L_ShadowBuffer[i]=iMAOnArray(L_Shadow,0,Periods,0,MODE_SMA,i);
 BodyBuffer[i]=iMAOnArray(Body,0,Periods,0,MODE_SMA,i); 
 
 }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+